#include "../client/client.h"
#include "../client/snd_loc.h"
//#include "dll.h"
#include "snddll.h"

/*
** File:    snd_amiga.c
** Date:    25-Dec-2001
** Purpose: SndDll glue code for loading external sound systems
** Author:  Hans-Joerg Frieden
** 
*/

//#define SOUND_IMPLEMENTED

void *      sound_library;
qboolean    soundlib_active;
sndexport_t se;
cvar_t *    s_lib = 0;

sndexport_t GetSndAPIAHI(sndimport_t simp);
sndexport_t GetSndAPISDL(sndimport_t simp);

extern void VID_Printf (int print_level, char *fmt, ...);
extern void VID_Error (int err_level, char *fmt, ...);


void SND_CheckChanges(void)
{
#ifdef SOUND_IMPLEMENTED	
    //hunoppc
  //  s_lib=Cvar_Get("s_lib","ahi",CVAR_ARCHIVE);
 //   cl_sounddriveros4 = Cvar_Get( "cl_sounddriveros4", "1", CVAR_ARCHIVE );
    if (s_lib && s_lib->modified == true)
	{
	extern void CL_Snd_Restart_f(void);
	CL_Snd_Restart_f();
	s_lib->modified = false;
	}
#endif	
}


void SND_FreeSoundlib(void)
{
#ifndef __amigaos4__
	if (sound_library) dllFreeLibrary(sound_library);
	memset (&se, 0, sizeof(se));
#endif
	soundlib_active = false;
}

int in_video = 0;

qboolean SND_LoadSoundlib(char *name)
{
#ifdef SOUND_IMPLEMENTED
	sndimport_t     si;

#ifndef __amigaos4__
cl_sounddriveros4->value = 1;
if( cl_sounddriveros4->value == 1 ){
//hunoppc
    Cvar_Set("s_lib", "sdl");
	GetSndAPI_t     GetSndAPIAHI;
    }else if( cl_sounddriveros4->value == 0 ){
//hunoppc
    Cvar_Set("s_lib", "sdl");
    GetSndAPI_t     GetSndAPISDL;
    }
#endif
	if (soundlib_active)
	{
	se.Shutdown(&dma);
	SND_FreeSoundlib();
	}
#ifndef __amigaos4__
	Com_Printf( "------- Loading %s -------\n", name );
	if ( (sound_library = dllLoadLibrary(name, name)) == 0)
	{
	Com_Printf ("LoadLibrary \"%s\" failed\n", name);
	return false;
	}
#endif
	si.Cmd_AddCommand = Cmd_AddCommand;
	si.Cmd_RemoveCommand = Cmd_RemoveCommand;
	si.Cmd_Argc = Cmd_Argc;
	si.Cmd_Argv = Cmd_Argv;
	si.Cmd_ExecuteText = Cbuf_ExecuteText;
	si.Con_Printf = VID_Printf;
	si.Sys_Error = VID_Error;
	si.FS_LoadFile = FS_LoadFile;
	si.FS_FreeFile = FS_FreeFile;
	si.FS_Gamedir = FS_Gamedir;
	si.Cvar_Get = Cvar_Get;
	si.Cvar_Set = Cvar_Set;
	si.Cvar_SetValue = Cvar_SetValue;
#ifndef __amigaos4__
if( cl_sounddriveros4->value == 1 ){
	if ( ( GetSndAPIAHI = (void *) dllGetProcAddress( sound_library, "GetSndAPIAHI" ) ) == 0 )
	Com_Error( ERR_FATAL, "GetProcAddress failed on %s", name );
    }else if( cl_sounddriveros4->value == 0 ){
    if ( ( GetSndAPISDL = (void *) dllGetProcAddress( sound_library, "GetSndAPISDL" ) ) == 0 )
	Com_Error( ERR_FATAL, "GetProcAddress failed on %s", name );
    }
#endif

	if (cl_sounddriveros4==0)
	{
		 cl_sounddriveros4 = Cvar_Get( "cl_sounddriveros4", "1", CVAR_ARCHIVE );
	}
	//in_video = 0;
	if (in_video)
	{
		Cvar_Set("s_lib", "sdl");
		se = GetSndAPISDL(si);
	}
	else
	{
		    Cvar_Set("s_lib", "sdl");
	cl_sounddriveros4->value = 1;
    if( cl_sounddriveros4->value == 1 ){
	se = GetSndAPISDL( si );
    }else if( cl_sounddriveros4->value == 0 ){
    se = GetSndAPISDL( si );
    }
	else
	se = GetSndAPISDL(si);
	}
#ifndef __amigaos4__
	if (se.api_version != SND_API_VERSION)
	{
	SND_FreeSoundlib ();
	Com_Error (ERR_FATAL, "%s has incompatible snd_api_version", name);
	}
#endif
	if ( se.Init( &dma ) == false )
	{
	se.Shutdown(&dma);

#ifndef __amigaos4__
	SND_FreeSoundlib ();
#endif
	soundlib_active = false;
	return false;
	}

	Com_Printf( "------------------------------------\n");
	soundlib_active = true;
	return true;
#else 
	return false;
#endif	
}


qboolean SNDDMA_Init(void)
{
#ifdef SOUND_IMPLEMENTED	
#ifndef __amigaos4__
	char name[100];
	if (!s_lib) s_lib = Cvar_Get("s_lib", "paula", CVAR_ARCHIVE);
	Com_sprintf(name, sizeof(name), "snd_%s.dll", s_lib->string);
#else
	char * name = "";
#endif

	return SND_LoadSoundlib(name);
#else
	return false;
#endif	
}

int     SNDDMA_GetDMAPos(void)
{
#ifdef SOUND_IMPLEMENTED	
	return se.GetDMAPos(&dma);
#else
	return 0;
#endif	
}

void SNDDMA_Shutdown(void)
{
	if (soundlib_active)
	{
#ifdef SOUND_IMPLEMENTED	
	se.Shutdown(&dma);
	SND_FreeSoundlib();
#endif
	}
}

void SNDDMA_BeginPainting (void)
{
#ifdef SOUND_IMPLEMENTED	
	if (se.BeginPainting) se.BeginPainting(&dma);
#endif
}

void SNDDMA_Submit(void)
{
#ifdef SOUND_IMPLEMENTED	
	if (se.Submit) se.Submit(&dma);
#endif
}
